@echo off

set problem=tetris
set lang=java

echo Compiling checker...

if exist Check.java javac -classpath testlib4j.jar Check.java -encoding utf8 

echo Generating tests...
if exist preliminary rd /s /q preliminary
if exist tests rd /s /q tests
cd src
if exist TestGen.py py -3 TestGen.py > ..\test.desc
cd ..

echo Compiling main solution...
if [%lang%]==[java] javac grader.java tetris.java -encoding utf8

echo Generating answers...

rem you can add tests folders here. For example: for %%s in (preliminary, tests, tests\subtask1, tests\subtask2)
for %%s in (preliminary, tests) do ( 
    for %%i in (%%s\??) do (
        echo Copying input for test %%i
        copy %%i %problem%.in > nul
        if exist validate.jar (
            echo Validating test %%i
            java -jar validate.jar < %problem%.in
            if errorlevel 1 (
                echo Validator rejects test %%i
                goto end
            )
            echo Validator accepts test %%i
        )

        echo Running solution on test %%i
        if [%lang%]==[java] java grader <%problem%.in >%problem%.out
        if errorlevel 1 (
            echo Solution failed on test %%i
            goto end
        )


        copy %problem%.out %%i.a > nul
        echo Running checker on test %%i
        if exist check.exe check %%i %%i.a %%i.a
        if exist Check.class java -Xmx256M -Xss64M -cp testlib4j.jar;. ru.ifmo.testlib.CheckerFramework Check %%i %%i.a %%i.a
        if errorlevel 1 (
            echo Checker rejects main solution output on test %%i
            goto end
        )
    )
)

:end