import random
random.seed("something")

class TestGen:
    def __init__(self):
        self.test_number = 0
        self.last_test_number = 0
        self.group_number = 0

    def generate_samples(self):
        self.print_test([1, 3, 2])

        
    def print_test(self, a):
        self.test_number += 1
        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(a), file=test_file)
        print(*a, file=test_file)
        test_file.close()


    def generate_tests(self, types):
        for n in [5, 10, 20, 50, 100, 250, 500, 1000]:
            a = []
            for i in range(n):
                a.append(types[random.randint(0, len(types) - 1)]);
            self.print_test(a);

        if (len(types) > 1):
            for k in types:
                a = []
                for i in range(n):
                    a.append(k);
                self.print_test(a);


    def nextGroup(self):
        print("Group", self.group_number, ":", self.last_test_number + 1, "-", self.test_number)
        self.last_test_number = self.test_number
        self.group_number += 1


    def generate_all_tests(self):
        self.generate_samples()
        self.nextGroup()
        self.generate_tests([1])
        self.nextGroup()
        self.generate_tests([2])
        self.nextGroup()
        self.generate_tests([1, 2])
        self.nextGroup()
        self.generate_tests([3])
        self.nextGroup()
        self.generate_tests([1, 2, 3])
        self.nextGroup()


import os, shutil
if os.path.exists('../tests'):
    print('Directory tests is already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)